#!/usr/bin/python

import sys
import mpgedit

class MyPlay:
    def __init__(self, mp3file):
        self.mp3file = mp3file
        self.count = 0
        
    def status(self, sec, msec):
        self.count += 1
        sys.stdout.write('Frame %5d: %02d.%03d sec\r' % (self.count, sec, msec))
        sys.stdout.flush();            
        return 1        

    def play(self):                           
        print 'Playing', self.mp3file
        mpgedit.Index(self.mp3file).index()
        p = mpgedit.Play(self.mp3file)  
        time = p.total_time()
        print 'Total: size=%d time=%d.%03d' % (p.total_size(), time[0], time[1])
        print 'Previous volume: left=%d right=%d' % p.get_volume()        
        p.set_volume(50, 100)
        print 'New volume: left=%d right=%d' % p.get_volume()        
        p.play(self.status) 
        
if __name__ == '__main__':
    try:
        MyPlay(sys.argv[1]).play()        
    except KeyboardInterrupt: pass
