#!/bin/sh
export PATH=$PATH:/usr/X11R6/bin
path=$0
dir=`dirname $path`

resdir=$dir/../Resources

#echo $HOME > /tmp/xmpgedit.out
cd $HOME
pwd >> /tmp/xmpgedit.out

#echo   DYLD_LIBRARY_PATH=$resdir HOME=$HOME _GTK_PIXMAP_PATH=$resdir >> /tmp/xmpgedit.out

if [ ! -f /tmp/.X0-lock ]; then
  NO_X_SERVER=1
else
  NO_X_SERVER=0
  XPID=`cat /tmp/.X0-lock`
  kill -0 $XPID > /dev/null 2>&1
  if [ $? -ne 0 ]; then
    NO_X_SERVER=1
  fi
fi

#
# Test for X server running...
#
#echo debug NO_X_SERVER=$NO_X_SERVER
if [ $NO_X_SERVER -eq 1 ]; then
  X > /dev/null 2>&1 &
  sleep 5

  #
  # Start window manager, since we just start X server, there certainly is not
  # one already running.
  #
  env DISPLAY=:0 quartz-wm > /dev/null 2>&1 &
else
  #
  # Test for running window manager, and start one if one is not found.
  #
  cnt1=`ps auxw | grep 'quartz-wm$' | grep -c -v grep`
  cnt2=`ps auxw | grep 'twm$'       | grep -c -v grep`

  #echo debug cnt1=$cnt1 cnt2=$cnt2
  if [ $cnt1 -eq 0 -a $cnt2 -eq 0 ]; then
    env DISPLAY=:0 quartz-wm > /dev/null 2>&1 &
  fi
fi

env -i DYLD_LIBRARY_PATH=$resdir HOME=$HOME _GTK_PIXMAP_PATH=$resdir $resdir/xmpgedit
