Summary: An MPEG 1 layer 1/2/3 (mp3), MPEG 2, and MPEG 2.5 audio file editor.
Name: mpgedit
Version: 0.72
Release: 0
Copyright: GPL
Group: Applications/Multimedia
Source: http://mpgedit.org/mpgedit/download_dev/mirror1/mpgedit_0-72beta_src.exe
BuildRoot: /var/tmp/%{name}-buildroot
Vendor: mpgedit.org

%description
mpgedit is an MPEG 1 layer 1/2/3 (mp3), MPEG 2, and MPEG 2.5 audio file
editor that is capable of processing both Constant Bit Rate (CBR) and
Variable Bit Rate (VBR) encoded files. mpgedit can cut an input MPEG file
into one or more output files, as well as join one or more input MPEG files
into a single output file. Since no file decoding / encoding occurs during
editing, there is no audio quality loss when editing with mpgedit. When
editing VBR files that have a XING header, mpgedit updates the output file's
XING header information to reflect the new file size and average bit rate.

%prep
/usr/src/redhat/SOURCES/mpgedit_0-72beta_src.exe -x
cd mpgedit_0-72beta_src/mpgedit
cp makefile.linux makefile

%build 
cd mpgedit_0-72beta_src/mpgedit
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS"

%install
cd mpgedit_0-72beta_src/mpgedit
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/bin
mkdir -p $RPM_BUILD_ROOT/usr/lib
mkdir -p $RPM_BUILD_ROOT/usr/share/doc
mkdir -p $RPM_BUILD_ROOT/usr/share/doc/mpgedit

install -s -m 755 mpgedit $RPM_BUILD_ROOT/usr/bin/mpgedit
install -s -m 755 mpgedit_nocurses $RPM_BUILD_ROOT/usr/bin/mpgedit_nocurses
install -m 755 mp3decoder.sh $RPM_BUILD_ROOT/usr/bin/mp3decoder.sh

install -m 755 libdecoder_mpg123.so $RPM_BUILD_ROOT/usr/lib/libdecoder_mpg123.so
install -m 755 libdecoder_popen.so $RPM_BUILD_ROOT/usr/lib/libdecoder_popen.so
install -m 755 libdecoder_mad.so $RPM_BUILD_ROOT/usr/lib/libdecoder_mad.so
install -m 755 libmpglib_mpgedit.so $RPM_BUILD_ROOT/usr/lib/libmpglib_mpgedit.so
ln -s $RPM_BUILD_ROOT/usr/lib/libdecoder_mpg123.so $RPM_BUILD_ROOT/usr/lib/libmpgedit_decoder.so



install -m 644 README $RPM_BUILD_ROOT/usr/share/doc/mpgedit/README
install -m 644 TODO $RPM_BUILD_ROOT/usr/share/doc/mpgedit/TODO
install -m 644 COPYING $RPM_BUILD_ROOT/usr/share/doc/mpgedit/COPYING
install -m 644 THANKS $RPM_BUILD_ROOT/usr/share/doc/mpgedit/THANKS
install -m 644 ChangeLog $RPM_BUILD_ROOT/usr/share/doc/mpgedit/ChangeLog

%clean
cd mpgedit_0-72beta_src/mpgedit
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc 
/usr/share/doc/mpgedit/README
/usr/share/doc/mpgedit/TODO
/usr/share/doc/mpgedit/COPYING
/usr/share/doc/mpgedit/THANKS
/usr/share/doc/mpgedit/ChangeLog

/usr/bin/mpgedit
/usr/bin/mpgedit_nocurses
/usr/bin/mp3decoder.sh

/usr/lib/libdecoder_mpg123.so
/usr/lib/libdecoder_popen.so
/usr/lib/libdecoder_mad.so
/usr/lib/libmpglib_mpgedit.so

%post
ln -f -s /usr/lib/libdecoder_mpg123.so /usr/lib/libmpgedit_decoder.so

%postun
[ -f /usr/lib/libdecoder_mpg123.so ] || rm -f /usr/lib/libmpgedit_decoder.so

%changelog
* Thu Oct 13 2005 * mpgedit -p playback is now supported with the -I flag.

* Thu Sep 8 2005  * xmpgedit file browser now caches last directory visited.

* Wed Sep 7 2005  * Added "main data begin" to mp3 frame -vvv statistics report.

* Sun Oct 2 2005  * Fixed libdecoder_popen.so playback decoder.

* Sat Jun 11 2005 * Added libdecoder_mad.so (lib MAD) playback decoder.

* Fri Mar 2 2005  * Added test case for mpgedit -vv frame number decoding to
                    test1.pl.
                  * Properly cleanup libmpgedit_decoder.so symbolic link when
                    libdecoder_mpg123.so no longer exists.
                  * Added readframes.c test program.

* Fri Feb 4 2005  * Fixed "mpgedit -I file.mp3" core dump.

* Tue Nov 30 2004 * Added RPM packaging for mpgedit and xmpgedit.
                  * Installation script and man RPM package runs makewhatis to
                    update man path.
                  * Changed Linux build to warn when pyrexc is not installed,
                    and print a reference for where it can be obtained.

* Sat Nov 27 2004 * Fixed xmpgedit SIGSEGV when editing mp3 files in a 
                    read-only directory then attempting to open the PCM file 
                    viewer.
* Mon Nov 22 2004 * Fixed -X2 option for mono mp3 and stereo/mono MPEG2/
                    MPEG2.5 files.
* Sat Nov 6 2004  * Fixed NULL pointer usage that occurred when the last file
                    remaining in the xmpgedit edit list is removed with 
                    File->Cut, resulting in a SIGSEGV error when editing 
* Sun Oct 31 2004 * Fixed buffer over run error that occurred when editing
                    mp3 files encoded at a slow bit rate, resulting in 
                    frequent SIGSEGV errors in xmpgedit when editing these 
                    files using the PCM file viewer.
* Sun Oct 17 2004 * Command line mpgedit is now capable of performing edits
                    without first generating an index file.  Use -I command
                    line option to enable this feature.
* Tue Oct 12 2004 * Fixed portability problem with PCM byte order processing
                    on big endian platforms.  This affects most UNIX platforms
                    and MAC OSX.  Fixed bug in curses mpgedit that prevented
                    last time in a file from being picked as an edit time.
                    Report an error when an edit time beyond the end of a 
                    file is selected.
